// ProgressStatusBar.cpp : implementation file
//

#include "stdafx.h"
#include "progres.h"
#include "ProgressStatusBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CProgressStatusBar

CProgressStatusBar::CProgressStatusBar()
{
	progress=NULL;
	Zauzet=false;
}

CProgressStatusBar::~CProgressStatusBar()
{
}


BEGIN_MESSAGE_MAP(CProgressStatusBar, CStatusBar)
	//{{AFX_MSG_MAP(CProgressStatusBar)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_PROGRESS_INIT,OnInit)
	ON_MESSAGE(WM_PROGRESS_END,OnEnd)
	ON_MESSAGE(WM_PROGRESS_SET_RANGE,OnSetRange)
	ON_MESSAGE(WM_PROGRESS_SET_STEP,OnSetStep)
	ON_MESSAGE(WM_PROGRESS_STEP_IT,OnStepIt)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressStatusBar message handlers

bool CProgressStatusBar::OnInit(WPARAM wParam, LPARAM lParam)
{
	if(Zauzet)
		return false;
	progress=new CProgressCtrl;
	CString* ispisi=(CString*)wParam; // string koji ispisujemo...
	ZauzimaTekst=GetDC()->GetTextExtent(*ispisi); // ... i njegova irina
	GetItemRect(0,&ZaProgres); // uzmi veliinu prvog polja
	tekst=new CStatic; 
	ZaTekst=CRect(0,ZaProgres.TopLeft().y+1,ZauzimaTekst.cx,ZaProgres.BottomRight().y); // sraunaj rectangle za tekst
	tekst->Create(*ispisi,WS_CHILD | WS_VISIBLE,ZaTekst,this); // kreiraj static kontrolu za tekst 
	tekst->SetFont(GetFont(),TRUE); // postavi font kao u status baru
	ZaProgres.DeflateRect(ZauzimaTekst.cx/2,0); // za irinu teksta smanji progres
	ZaProgres.OffsetRect(ZauzimaTekst.cx/2,0); // i pomeri ga desno za isto toliko
	progress->Create(WS_VISIBLE,ZaProgres,this,ID_PROGRES); // kreiraj progres kontrolu
	StariTekst=GetPaneText(0); // uzmi stari tekst iz prvog polja
	UpdateWindow(); // forsiraj iscrtavanje
	return (Zauzet=true);
}

void CProgressStatusBar::OnEnd(WPARAM wParam, LPARAM lParam)
{
	if(Zauzet!=bool(wParam))
		return;
	delete progress; // obrii progres
	progress=NULL;
	delete tekst; // obriri tekst
	SetPaneText(0,StariTekst); // vrati stari tekst
	UpdateWindow(); // forsiraj iscrtavanje
	Zauzet=false; // daj priliku novim nitima
}

void CProgressStatusBar::OnSetRange(WPARAM wParam, LPARAM lParam)
{
	if(Zauzet!=bool(wParam))
		return;
	if(progress!=NULL)
		progress->SetRange(1,int(lParam));
}
void CProgressStatusBar::OnSetStep(WPARAM wParam, LPARAM lParam)
{
	if(Zauzet!=bool(wParam))
		return;
	if(progress!=NULL)
		progress->SetStep(int(lParam));
}
void CProgressStatusBar::OnStepIt(WPARAM wParam, LPARAM lParam)
{
	if(Zauzet!=bool(wParam))
		return;
	if(progress!=NULL)
		progress->StepIt();
}

void CProgressStatusBar::OnSize(UINT nType, int cx, int cy) 
{
	CStatusBar::OnSize(nType, cx, cy);
	GetItemRect(0,&ZaProgres);
	ZaProgres.DeflateRect(ZauzimaTekst.cx/2,0); // za irinu teksta smanji progres
	ZaProgres.OffsetRect(ZauzimaTekst.cx/2,0); // i pomeri ga desno za isto toliko
	if(progress!=NULL)
		progress->MoveWindow(&ZaProgres); // prati pomeranje status bara
}
